DefaultStyledDocument.AttributeUndoableEdit (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: javax.swing.text, class: DefaultStyledDocument, class: AttributeUndoableEdit
Keywords: javax.swing.text.DefaultStyledDocument.AttributeUndoableEdit class

# Class DefaultStyledDocument.AttributeUndoableEdit

java.lang.Object
javax.swing.undo.AbstractUndoableEdit
javax.swing.text.DefaultStyledDocument.AttributeUndoableEdit

All Implemented Interfaces:
  `Serializable, UndoableEdit`

Enclosing class:
  `DefaultStyledDocument`

public static class DefaultStyledDocument.AttributeUndoableEdit extends AbstractUndoableEdit
An UndoableEdit used to remember AttributeSet changes to an Element.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected AttributeSet`
  `copy`
  Copy of the AttributeSet the Element contained.
  `protected Element`
  `element`
  Affected Element.
  `protected boolean`
  `isReplacing`
  true if all the attributes in the element were removed first.
  `protected AttributeSet`
  `newAttributes`
  AttributeSet containing additional entries, must be non-mutable!

  ### Fields declared in class AbstractUndoableEdit

  `RedoName, UndoName`
  Modifier and Type
  Field
  Description
  `protected static final String`
  `RedoName`
  String returned by `getRedoPresentationName`; as of Java 2 platform v1.3.1 this field is no longer used.
  `protected static final String`
  `UndoName`
  String returned by `getUndoPresentationName`; as of Java 2 platform v1.3.1 this field is no longer used.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AttributeUndoableEdit(Element element, AttributeSet newAttributes, boolean isReplacing)`
  Constructs an `AttributeUndoableEdit`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `redo()`
  Redoes a change.
  `void`
  `undo()`
  Undoes a change.

  ### Methods declared in class AbstractUndoableEdit

  `addEdit, canRedo, canUndo, die, getPresentationName, getRedoPresentationName, getUndoPresentationName, isSignificant, replaceEdit, toString`
  Modifier and Type
  Method
  Description
  `boolean`
  `addEdit(UndoableEdit anEdit)`
  This default implementation returns false.
  `boolean`
  `canRedo()`
  Returns `true` if this edit is `alive` and `hasBeenDone` is `false`.
  `boolean`
  `canUndo()`
  Returns true if this edit is `alive` and `hasBeenDone` is `true`.
  `void`
  `die()`
  Sets `alive` to false.
  `String`
  `getPresentationName()`
  This default implementation returns "".
  `String`
  `getRedoPresentationName()`
  Retrieves the value from the defaults table with key `AbstractUndoableEdit.redoText` and returns that value followed by a space, followed by `getPresentationName`.
  `String`
  `getUndoPresentationName()`
  Retrieves the value from the defaults table with key `AbstractUndoableEdit.undoText` and returns that value followed by a space, followed by `getPresentationName`.
  `boolean`
  `isSignificant()`
  This default implementation returns true.
  `boolean`
  `replaceEdit(UndoableEdit anEdit)`
  This default implementation returns false.
  `String`
  `toString()`
  Returns a string that displays and identifies this object's properties.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Field Details

  - ### newAttributes

    protected AttributeSet newAttributes
    AttributeSet containing additional entries, must be non-mutable!

  - ### copy

    protected AttributeSet copy
    Copy of the AttributeSet the Element contained.

  - ### isReplacing

    protected boolean isReplacing
    true if all the attributes in the element were removed first.

  - ### element

    protected Element element
    Affected Element.

- ## Constructor Details

  - ### AttributeUndoableEdit

    public AttributeUndoableEdit(Element element, AttributeSet newAttributes, boolean isReplacing)
    Constructs an `AttributeUndoableEdit`.
    Parameters:
      `element` - the element
      `newAttributes` - the new attributes
      `isReplacing` - true if all the attributes in the element were removed first.

- ## Method Details

  - ### redo

    public void redo() throws CannotRedoException
    Redoes a change.
    Specified by:
      `redo` in interface `UndoableEdit`
    Overrides:
      `redo` in class `AbstractUndoableEdit`
    Throws:
      `CannotRedoException` - if the change cannot be redone
    See Also:
      - `AbstractUndoableEdit.canRedo()`

  - ### undo

    public void undo() throws CannotUndoException
    Undoes a change.
    Specified by:
      `undo` in interface `UndoableEdit`
    Overrides:
      `undo` in class `AbstractUndoableEdit`
    Throws:
      `CannotUndoException` - if the change cannot be undone
    See Also:
      - `AbstractUndoableEdit.canUndo()`